#!/usr/bin/perl

$base_x = "1.979mm";
$base_y = "1.979mm";


while (<>) {
	chop;
	chop if (/\r$/);
	if (/^X([0-9]+)Y([0-9]+)D([0-9]+)\*/) {
		$x = $1;
		$y = $2;
		$d = $3;
		$x += calc_off($base_x);
		$y += calc_off($base_y);
		$x = $x * 2;
		$y = $y * 2;
		$s = sprintf("X%06dY%06dD%s\*\n",$x,$y,$d);
		print $s;
	} else {
		printf("%s\n",$_);
	}
}

sub calc_off {
    my($in,$off);
    $in = @_[0];
    $in =~ m/^(-*[0-9]+|-*[0-9]*\.[0-9]*)(|mm|in)$/;
    $off = $1;
    if ($2 =~ /^mm/) {
	    $off = $off * 10000 / 25.4;
    } elsif ($2 =~ /^in/) {
	    $off = $off * 10000;
    } else { # default inch
	    $off = $off * 10000;
    }
    return $off;
}
